import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:osam/osam.dart';

final t = TestState();

void main() {
  runApp(MaterialApp(
    home: Container(
      color: Colors.greenAccent,
      alignment: Alignment.center,
      child: Test(),
    ),
  ));
}

class Test extends StatefulWidget {
  const Test({Key key}) : super(key: key);

  @override
  _TestState createState() => _TestState();
}

class _TestState extends State<Test> {
  var isVisible = false;

  @override
  Widget build(BuildContext context) {
    return Center(
      child: Column(
        mainAxisAlignment: MainAxisAlignment.center,
        mainAxisSize: MainAxisSize.min,
        children: <Widget>[
//          if (isVisible)
          StreamBuilder(
            initialData: t.num,
            stream: t.propertyStream((state) => state.num),
            builder: (ctx, snap) => Text(snap.data.toString()),
          ),
          RaisedButton(
            onPressed: () {
              t.update((state) => state.num++);
            },
          )
        ],
      ),
    );
  }
}

class TestState extends BaseState<TestState> {
  var num = 0;

  TestState() : super();

  @override
  List<Object> get props => [num];
}
